import { QueryBase } from '@mobicoop/ddd-library';
import { Frequency } from '@modules/matcher/core/domain/match.types';
import { ScheduleItem } from '../../types/schedule-item';
import { Waypoint } from '../../types/waypoint';

export class MatchQuery extends QueryBase {
  readonly driver?: boolean;
  readonly passenger?: boolean;
  readonly frequency?: Frequency;
  readonly fromDate: string;
  readonly toDate: string;
  readonly schedule: ScheduleItem[];
  readonly strict?: boolean;
  readonly waypoints: Waypoint[];

  constructor(props: MatchQuery) {
    super();
    this.driver = props.driver;
    this.passenger = props.passenger;
    this.frequency = props.frequency;
    this.fromDate = props.fromDate;
    this.toDate = props.toDate;
    this.schedule = props.schedule;
    this.strict = props.strict;
    this.waypoints = props.waypoints;
  }
}
